trait Observer[T]:
  def onNext(value: T): Unit
  def onError(error: Throwable): Unit
  def onComplete(): Unit

object Observer:
  def apply[T](n: T => Unit, 
               e: Throwable => Unit = throw _, 
               c: => Unit = ()) = new Observer[T]: 
    def onNext(value: T): Unit = n(value)
    def onError(error: Throwable): Unit = e(error)
    def onComplete(): Unit = c  